import { Transform, Parser } from 'jscodeshift';
import VueTransformation from './VueTransformation';
declare type FileInfo = {
    path: string;
    source: string;
};
declare type JSTransformation = Transform & {
    type: 'JSTransformation';
    parser?: string | Parser;
};
declare type JSTransformationModule = JSTransformation | {
    default: Transform;
    parser?: string | Parser;
};
declare type VueTransformationModule = VueTransformation | {
    default: VueTransformation;
};
export declare type TransformationModule = JSTransformationModule | VueTransformationModule;
export default function runTransformation(fileInfo: FileInfo, transformationModule: TransformationModule, params?: object): string;
export {};
