"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runTest = void 0;
jest.autoMockOff();
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const runTransformation_1 = __importDefault(require("./runTransformation"));
const transformations_1 = __importDefault(require("../transformations"));
const vue_transformations_1 = __importDefault(require("../vue-transformations"));
const runTest = (description, transformationName, fixtureName, extension = 'vue', transformationType = 'vue') => {
    test(description, () => {
        const fixtureDir = path.resolve(__dirname, transformationType == 'vue'
            ? '../vue-transformations'
            : '../wrapAstTransformation', './__testfixtures__', transformationName);
        const inputPath = path.resolve(fixtureDir, `${fixtureName}.input.${extension}`);
        const outputPath = path.resolve(fixtureDir, `${fixtureName}.output.${extension}`);
        const fileInfo = {
            path: inputPath,
            source: fs.readFileSync(inputPath).toString()
        };
        const transformation = (transformationType == 'vue' ? vue_transformations_1.default : transformations_1.default)[transformationName];
        expect(runTransformation_1.default(fileInfo, transformation)).toEqual(fs.readFileSync(outputPath).toString());
    });
};
exports.runTest = runTest;
