import type { Operation } from './operationUtils';
import type VueTransformation from './VueTransformation';
import { Node } from 'vue-eslint-parser/ast/nodes';
declare type FileInfo = {
    path: string;
    source: string;
};
export declare type Context = {
    file: FileInfo;
};
export declare type VueASTTransformation<Params = void> = {
    (context: Context, params: Params): Operation[];
    type?: string;
};
export declare function createTransformAST(nodeFilter: (node: Node) => boolean, fix: (node: Node, source?: string) => Operation[], ruleName: string): VueASTTransformation<void>;
export default function astTransformationToVueTransformationModule<Params = any>(transformAST: VueASTTransformation<Params>): VueTransformation;
/**
 * Modify source files
 * @param sourceCode File's source code
 * @param tempOperations Modify the object
 */
export declare function applyOperation(sourceCode: string, tempOperations: Operation[]): string;
export {};
