"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const element_plus_import_1 = require("./element-plus/element-plus-import");
const element_plus_component_name_1 = require("./element-plus/element-plus-component-name");
const locale_lang_file_lower_case_1 = require("./element-plus/locale-lang-file-lower-case");
const report_1 = require("../src/report");
const transformAST = context => {
    const beforeCount = Object.keys(subRules).reduce((sum, key) => sum + subRules[key], 0);
    element_plus_import_1.transformAST(context);
    element_plus_component_name_1.transformAST(context);
    locale_lang_file_lower_case_1.transformAST(context);
    const afterCount = Object.keys(subRules).reduce((sum, key) => sum + subRules[key], 0);
    const change = afterCount - beforeCount;
    const cntFunc = report_1.getCntFunc('element-ui-upgrade', global.outputReport);
    cntFunc(change);
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
