"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const transformAST = ({ root, j }) => {
    const importValuePrefix = 'element-plus/lib/locale/lang/';
    // find element-ui lang import
    const langImport = root.find(j.ImportDeclaration, node => {
        var _a;
        return (node.source.type === 'StringLiteral' && ((_a = node.source.value) === null || _a === void 0 ? void 0 : _a.startsWith(importValuePrefix)));
    });
    if (langImport.length) {
        langImport.replaceWith(({ node }) => {
            const value = node.source.value;
            const lang = value.replace(importValuePrefix, '');
            // if lang contains upper-case,converts to lower-case
            if (/[A-Z]+/.test(lang)) {
                node.source.value = importValuePrefix + lang.toLowerCase();
            }
            return node;
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
