"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const transformAST = ({ root, j }) => {
    const cntFunc = report_1.getCntFunc('global-filter', global.outputReport);
    // find the createApp()
    const constApp = root.find(j.VariableDeclarator, {
        id: {
            name: 'app'
        }
    });
    if (constApp.length <= 0) {
        return;
    }
    const vueCreateApp = j(constApp === null || constApp === void 0 ? void 0 : constApp.at(0).get().value.init).find(j.MemberExpression, {
        object: {
            name: 'Vue'
        },
        property: {
            name: 'createApp'
        }
    });
    if (!constApp.length || !vueCreateApp.length) {
        return;
    }
    const appName = constApp.at(0).get().value.id.name;
    // Vue.filter('filterName', function(value) {}) =>
    // app.config.globalProperties.$filters = { filterName(value) {} }
    const filters = root.find(j.ExpressionStatement, {
        expression: {
            type: 'CallExpression',
            callee: {
                type: 'MemberExpression',
                object: { type: 'Identifier', name: 'Vue' },
                property: { type: 'Identifier', name: 'filter' }
            }
        }
    });
    if (!filters.length) {
        return;
    }
    cntFunc();
    const methods = [];
    for (let i = 0; i < filters.length; i++) {
        const filter = filters.at(i);
        const args = filter.get().node.expression.arguments;
        methods.push(j.objectMethod('method', j.identifier(args[0].value), args[1].params, args[1].body));
    }
    filters
        .at(0)
        .insertBefore(j.expressionStatement(j.assignmentExpression('=', j.memberExpression(j.identifier(appName), j.identifier('config.globalProperties.$filters'), false), j.objectExpression(methods))));
    for (let i = 0; i < filters.length; i++) {
        filters.at(i).remove();
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
