"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const rootNodes = root.find(j.MemberExpression, {
        object: {
            object: {
                name: 'Vue'
            },
            property: {
                name: 'config'
            }
        },
        property: {
            name: 'KeyCodes'
        }
    });
    if (rootNodes) {
        rootNodes.forEach((node) => {
            const path = filename;
            const name = 'Removed keyCodes modifiers';
            const suggest = 'For those using keyCode in their codebase, we recommend converting them to their kebab-cased named equivalents.';
            const website = 'https://v3.vuejs.org/guide/migration/keycode-modifiers.html';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
