"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const rootNodes = root
        .find(j.Identifier)
        .filter(node => node.value.name === '$on' ||
        node.value.name === '$once' ||
        node.value.name === '$off');
    if (rootNodes) {
        rootNodes.forEach((node) => {
            const path = filename;
            const name = 'Removed $on, $once and $off instance method';
            const suggest = '$on, $off and $once instance methods are removed. Component instances no longer implement the event emitter interface.';
            const website = 'https://v3.vuejs.org/guide/migration/events-api.html#overview';
            report_1.pushManualList(path, node, name, suggest, website);
        });
    }
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
