"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const remove_extraneous_import_1 = require("./remove-extraneous-import");
const _ = __importStar(require("lodash"));
const report_1 = require("../src/report");
const transformAST = context => {
    const { root, j, filename } = context;
    const cntFunc = report_1.getCntFunc('new-component-api', global.outputReport);
    const rootExpressionStatement = root
        .find(j.ExpressionStatement)
        .filter(path => path.parent.value.type === 'Program');
    if (rootExpressionStatement.length > 1) {
        return;
    }
    // find Vue.component
    const componentRegistration = root
        .find(j.CallExpression, {
        callee: {
            type: 'MemberExpression',
            object: {
                name: 'Vue'
            },
            property: {
                name: 'component'
            }
        }
    })
        .filter(path => {
        return path.parent.parent.value.type === 'Program';
    });
    let componentArgs = [];
    componentRegistration.forEach(({ node }) => {
        if (node.arguments.length === 2) {
            componentArgs = node.arguments;
            let componentApi;
            cntFunc();
            if (j.Identifier.check(componentArgs[1])) {
                componentApi = { name: componentArgs[1].name, path: filename };
            }
            else {
                componentApi = {
                    name: _.upperFirst(_.camelCase(componentArgs[0].value)),
                    path: filename
                };
            }
            global.globalApi.push(componentApi);
        }
    });
    // app.component()
    const componentCall = j.callExpression(j.memberExpression(j.identifier('app'), j.identifier('component')), componentArgs);
    // app => { app.component() }
    const installArrowFunction = j.arrowFunctionExpression([j.identifier('app')], j.blockStatement([j.expressionStatement(componentCall)]));
    // { install: app => {app.component() } }
    const objectExpression = j.objectExpression([
        j.objectProperty(j.identifier('install'), installArrowFunction)
    ]);
    // export default {}
    const exportDefaultDeclaration = j.exportDefaultDeclaration(objectExpression);
    componentRegistration.replaceWith(() => exportDefaultDeclaration);
    remove_extraneous_import_1.transformAST(context, { localBinding: 'Vue' });
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
