"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const lifecycleMap = {
    destroyed: 'unmounted',
    beforeDestroy: 'beforeUnmount'
};
const transformAST = ({ root, j }) => {
    const cntFunc = report_1.getCntFunc('rename-lifecycle', global.outputReport);
    const methodArray = [j.ObjectProperty, j.ObjectMethod, j.ClassProperty];
    methodArray.forEach(method => {
        const methods = root.find(method);
        if (methods.length) {
            methods.forEach(path => {
                var _a, _b, _c;
                // @ts-ignore
                const beforeReplaceName = path.node.key.name;
                const afterReplaceName = lifecycleMap[beforeReplaceName];
                if (afterReplaceName &&
                    ((_c = (_b = (_a = path.parent) === null || _a === void 0 ? void 0 : _a.parent) === null || _b === void 0 ? void 0 : _b.value) === null || _c === void 0 ? void 0 : _c.type) === 'ExportDefaultDeclaration') {
                    // @ts-ignore
                    path.value.key.name = afterReplaceName;
                    cntFunc();
                }
            });
        }
    });
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
