"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../../src/wrapAstTransformation"));
const report_1 = require("../../src/report");
// router.onReady(succes,err) => router.isReady().then(succes).catch(error)
const transformAST = ({ j, root }) => {
    const cntFunc = report_1.getCntFunc('router4-onready-to-isready', global.outputReport);
    // find onReady
    const readyExpresstion = root.find(j.CallExpression, {
        callee: {
            type: 'MemberExpression',
            object: {
                name: 'router' || 'route'
            },
            property: {
                type: 'Identifier',
                name: 'onReady'
            }
        }
    });
    // .filter(node => node.callee.object.name === 'router')
    if (!readyExpresstion.length)
        return;
    readyExpresstion.replaceWith(({ node }) => {
        const express = node.callee;
        const params = node.arguments;
        //@ts-ignore
        express.property.name = 'isReady';
        const successFn = j.callExpression(j.memberExpression(j.callExpression(express, []), j.identifier('then')), [params[0]]);
        if (params.length == 1) {
            return successFn;
        }
        cntFunc();
        return j.callExpression(j.memberExpression(successFn, j.identifier('catch')), [params[1]]);
    });
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
