"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const transformAST = ({ j, root }) => {
    const cntFunc = report_1.getCntFunc('scoped-slots-to-slots', global.outputReport);
    const dotScopedSlots = root.find(j.MemberExpression, {
        property: {
            type: 'Identifier',
            name: '$scopedSlots'
        }
    });
    dotScopedSlots.forEach(({ node }) => {
        ;
        node.property.name = '$slots';
        cntFunc();
    });
    const squareBracketScopedSlots = root.find(j.MemberExpression, {
        property: {
            type: 'StringLiteral',
            value: '$scopedSlots'
        }
    });
    squareBracketScopedSlots.forEach(({ node }) => {
        node.property = j.stringLiteral('$slots');
        cntFunc();
    });
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
