"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parser = exports.transformAST = void 0;
const wrapAstTransformation_1 = __importDefault(require("../src/wrapAstTransformation"));
const report_1 = require("../src/report");
const transformAST = ({ root, j }) => {
    const cntFunc = report_1.getCntFunc('vuex-create-logger', global.outputReport);
    //  find the import xxx from 'vuex/dist/logger'
    const importDeclarationCollection = root.find(j.ImportDeclaration, node => {
        return (node.specifiers.length === 1 &&
            node.specifiers[0].type === 'ImportDefaultSpecifier' &&
            node.source.value === 'vuex/dist/logger');
    });
    if (!importDeclarationCollection.length)
        return;
    cntFunc();
    const importName = importDeclarationCollection.get(0).node.specifiers[0].local.name;
    if (importName !== 'createLogger') {
        //  rename function name
        root
            .find(j.CallExpression, node => {
            return node.callee.name === importName;
        })
            .replaceWith(({ node }) => {
            // @ts-ignore
            return j.callExpression(j.identifier('createLogger'), node.arguments);
        });
    }
    //  remove import
    importDeclarationCollection.remove();
    //  add import
    const addImport = require('./add-import');
    addImport.transformAST({ root, j }, {
        specifier: {
            type: 'named',
            imported: 'createLogger'
        },
        source: 'vuex'
    });
};
exports.transformAST = transformAST;
exports.default = wrapAstTransformation_1.default(exports.transformAST);
exports.parser = 'babylon';
