"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const parser = __importStar(require("vue-eslint-parser"));
const wrapVueTransformation_1 = __importDefault(require("../../src/wrapVueTransformation"));
const report_1 = require("../../src/report");
const transformAST = context => {
    let fixOperations = [];
    findNodes(context);
    return fixOperations;
};
exports.transformAST = transformAST;
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function findNodes(context) {
    const { file } = context;
    const source = file.source;
    const options = { sourceType: 'module' };
    const ast = parser.parse(source, options);
    let toFixNodes = [];
    let root = ast.templateBody;
    let key = /^key{1}/;
    let number = /^\d+/;
    parser.AST.traverseNodes(root, {
        enterNode(node) {
            var _a, _b, _c;
            if (node.type === 'VDirectiveKey' &&
                ((_a = node === null || node === void 0 ? void 0 : node.name) === null || _a === void 0 ? void 0 : _a.name) === 'on' &&
                // @ts-ignore
                key.test((_b = node === null || node === void 0 ? void 0 : node.argument) === null || _b === void 0 ? void 0 : _b.name) &&
                number.test((_c = node === null || node === void 0 ? void 0 : node.modifiers[0]) === null || _c === void 0 ? void 0 : _c.name)) {
                toFixNodes.push(node);
            }
        },
        leaveNode(node) { }
    });
    toFixNodes.forEach(node => {
        const path = file.path;
        const name = 'Removed keyCodes modifiers';
        const suggest = 'For those using keyCode in their codebase, we recommend converting them to their kebab-cased named equivalents.';
        const website = 'https://v3.vuejs.org/guide/migration/keycode-modifiers.html';
        report_1.VuePushManualList(path, node, name, suggest, website);
    });
}
