"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const wrapVueTransformation_1 = __importStar(require("../src/wrapVueTransformation"));
exports.transformAST = wrapVueTransformation_1.createTransformAST(nodeFilter, fix, 'remove-v-on-native');
exports.default = wrapVueTransformation_1.default(exports.transformAST);
/**
 * Filter for v-on nodes
 */
function nodeFilter(node) {
    return (node.type === 'VAttribute' && node.directive && node.key.name.name === 'on');
}
/**
 * fix logic
 * @param node
 */
function fix(node) {
    let fixOperations = [];
    // @ts-ignore
    const keyNode = node.key;
    const argument = keyNode.argument;
    const modifiers = keyNode.modifiers;
    if (argument !== null) {
        modifiers.forEach((mod) => {
            if ((mod === null || mod === void 0 ? void 0 : mod.name) === 'native') {
                const comment = '<!-- native modifier has been removed, please confirm whether the function has been affected  -->';
                const vStartTag = mod.parent.parent.parent;
                const vElement = vStartTag.parent;
                const siblings = vElement.parent.children;
                let insertIndent = '';
                if (siblings[0] !== vElement) {
                    let preEle = siblings[0];
                    for (let i = 1; i < siblings.length; i++) {
                        if (siblings[i].range === vElement.range) {
                            insertIndent = preEle.value;
                            break;
                        }
                        else {
                            preEle = siblings[i];
                        }
                    }
                }
                // insert a comment about navite modifier
                fixOperations.push(OperationUtils.insertTextBefore(vStartTag, comment));
                // insert new line and indents
                fixOperations.push(OperationUtils.insertTextBefore(vStartTag, insertIndent));
                // remove native modifier on 'v-on' directive
                fixOperations.push(OperationUtils.removeRange([mod.range[0] - 1, mod.range[1]]));
            }
        });
    }
    return fixOperations;
}
