"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformAST = void 0;
const OperationUtils = __importStar(require("../src/operationUtils"));
const wrapVueTransformation_1 = __importStar(require("../src/wrapVueTransformation"));
const debug_1 = __importDefault(require("debug"));
const debug = debug_1.default('vue-codemod:rule');
exports.transformAST = wrapVueTransformation_1.createTransformAST(nodeFilter, fix, 'v-else-if-key');
exports.default = wrapVueTransformation_1.default(exports.transformAST);
function nodeFilter(node) {
    // filter for slot attribute node
    return (node.type === 'VAttribute' &&
        node.key.type === 'VIdentifier' &&
        node.key.name === 'key');
}
/**
 * The repair logic for
 * @param node The Target Node
 */
function fix(node) {
    let fixOperations = [];
    const target = node.parent.parent;
    // The current node has no attribute that is v-for
    let hasTargetAttr = false;
    target.startTag.attributes
        .filter((attr) => attr.type === 'VAttribute' &&
        attr.key.type === 'VDirectiveKey' &&
        (attr.key.name.name === 'if' ||
            attr.key.name.name === 'else-if' ||
            attr.key.name.name === 'else'))
        .forEach(() => {
        hasTargetAttr = true;
    });
    if (!hasTargetAttr) {
        debug('No operator, target element is not if/else-if/else.');
        return fixOperations;
    }
    fixOperations.push(OperationUtils.remove(node));
    return fixOperations;
}
